#!/usr/bin/php
<?php

error_reporting(E_ALL);
ini_set('display_errors', 'On');

/**
 * Generate C source on stdout. 
 *
 * @param int $divisor Numeric divisor
 */
function generate($divisor) {
	
?>
#include <stddef.h>

#define DIVISIBLE_TRUE 1
#define DIVISIBLE_FALSE 0

char is_divisible_by_<?=$divisor?>(unsigned char *input, size_t input_nbytes) {	

<?php for($k = 0; $k < $divisor; ++$k) { ?> 
<?=sprintf("divisor_%x_%x:", $divisor, $k)?>

	if (input_nbytes == 0)
		return DIVISIBLE_<?=($k == 0 ? 'TRUE' : 'FALSE')?>;
	input_nbytes--;
	
	switch(input[input_nbytes]) {

<?php
	
		$buckets = [];
		for($d = 0; $d < 256; ++$d) {
			$target = ( ($k * 256) + $d ) % $divisor;
			if (! isset($buckets[$target])) {
				$buckets[$target] = [];
			}
			$buckets[$target][] = $d;
		}
	
		foreach($buckets as $target => $bucket) {
			for($i = 0; $i < count($bucket); $i += 4) {
				echo "\t\t".implode("", array_map(function($e) { return sprintf("%-10s", "case $e:");}, array_slice($bucket, $i, 4)))."\n";
			}
			echo "\t\t\tgoto ".sprintf("divisor_%x_%x", $divisor, $target).";\n";
		}
?>
	}
<?php } ?>
}
<?php

}

function main($argv) {
	if (count($argv) !== 1) {
		echo "FATAL: expected exactly one numeric argument\n";
		return false;
	}
	
	generate($argv[0]);
	
	return true;
}

die(main(array_slice($_SERVER['argv'], 1)) ? 0 : 1);
